-- Is this Buddy Hyllberg? If you're reading this, is this file yours? Is it
-- okay if I use it? My email is Prog_Matt@Yahoo.com. BTW, there was a bug
-- in COMPRESS.E. When expanding the bytes, the byte indicating the number
-- of dupes went after the dupes. To fix this, I turned the for...end for
-- loop in inflate() to a while...end while loop so I can manipulate the loop.
-- It will increase the counter by one when it expands

-- basic repeating character compression functions

global function compress( sequence data )
  atom char, lastchar
  sequence buf, stack
  buf = {}  stack = {}
  lastchar = -1
  for i = 1 to length(data) do
    char = data[i]
    if equal(char, lastchar) then  -- if it's a dupe, add it to the stack
      stack &= char
      lastchar = char
    else
      if length(stack) > 2 then     -- don't compress less than 3 dupes
	buf &= #FF & length(stack)
	stack = {}
      else
	buf &= stack
	stack = {}
      end if
      lastchar = char
      buf &= char
    end if
  end for
  if length(stack) > 1 then     -- finish off any dupes at the end
    buf &= #FF & length(stack)
  else
	buf &= stack
  end if
  return buf
end function


global function inflate( sequence data )
	atom char, lastchar
	integer i
	sequence buf  buf = {}
	i=0
	lastchar = -1
	while 1 do
	    i += 1
	    if i > length(data) then
		exit
	    end if
	    char = data[i]
	    if char = #FF then  -- expand the compressed bytes
		    buf &= repeat(lastchar, data[i+1])
		    i += 1
		    lastchar = char
	    else
		    buf &= char
		    lastchar = char
	    end if
	end while
	return buf
end function
