include compress.e
include common.e

constant comms = {"add","modify","delete","current","select","find","view","write",
		  "world","new","open","print","quit"},
	 actions = {"append","insert","clear","delete","cancel"}
sequence procs,notes,ntFile,bk,pos,cmd
integer fn,key,rec,doQuit,er,justViewed,doSave
object line
doSave=1
justViewed=0
doQuit=0
rec=1
notes={}
ntFile="enotes.db"
er=0
fn=open("enotes.cfg","r")
if fn > -1 then
    line=gets(fn)
    if sequence(line) then
	ntFile=line
    end if
    close(fn)
else
    fn=open("enotes.cfg","w")
    if fn > -1 then
	puts(fn,ntFile)
	close(fn)
    end if
end if
cmd=command_line()
if length(cmd)>2 then
    ntFile=cmd[3]
end if
procedure readDb()
    text_color(11)
    puts(1,translate("fn")&' '&ntFile&'\n')
    puts(1,translate("reading")&"...\n")
    fn=open(ntFile,"rb")
    if fn=-1 then
	doSave=0
	puts(1,translate("cantfind")&' '&ntFile&'\n')
	notes={0,{}}
    else
	doSave=1
	notes=inflate(get_bytes(fn,lof(fn)))
	close(fn)
	fn=open(ntFile,"w")
	puts(fn,notes)
	close(fn)
	fn=open(ntFile,"r")
	notes=get(fn)
	close(fn)
    end if
    if notes[1] != GET_SUCCESS then
	puts(1,translate("corrupt")&'\n')
	er=1
	notes={0,{}}
    end if
    notes=notes[2]
    bak=notes
    printf(1,"%s %d %s\n",{translate("thereare"),length(notes),translate("records")})
end procedure
procedure welcome()
    position(1,floor((maxC-10)/2-2)) puts(1,"Ŀ")
    position(2,floor((maxC-10)/2-2)) puts(1,"   ENotes v1.0   ")
    position(3,floor((maxC-10)/2-2)) puts(1,"\n\n"&
					    repeat(196,maxC)&'\n')
end procedure
fn=open("data.cfg","r")
if fn=-1 then
    setLanguage("us")
    languages={"us","fr","gr","sp"}
else
    line=gets(fn)
    if atom(line) then
	line="us"
	setLanguage("us")
    else
	if line[length(line)]=10 then
	    line=line[1..length(line)-1]
	end if
	setLanguage(line)
	languages=get(fn)
	if languages[1] = GET_SUCCESS then
	    languages=languages[2]
	end if
    end if
    close(fn)
end if
procedure quit()
    integer k
    if not equal(notes,bak) then
	puts(1,translate("save?")&'\n')
	k=getKey(xlateAll({"yes","no","cancel"}),0)
	if k=1 then
	    bak=notes
	elsif k=3 then
	    doQuit=0
	    return
	end if
    end if
    doQuit=1
end procedure
procedure world()
    sequence msg
    integer k,fn
    clear_screen()
    msg=translate("select")&' '&translate("language")&'\n'
    puts(1,msg&repeat(196,length(msg))&'\n')
    k=getKey(xlateAll(languages),0)
    setLanguage(languages[k])
    clear_screen()
    fn=open("data.cfg","w")
    puts(fn,languages[k]&'\n')
    print2(fn,languages)
    close(fn)
    welcome()
end procedure
procedure add()
    sequence nts,line,msg,subject
    integer cnt
    text_color(11)
    msg=translate("adding")
    subject=prompt_string(translate("subj")&' ')
    if equal(subject,"") then
	puts(1,translate("procabort")&'\n')
	return
    end if
    puts(1,msg&'\n')
    puts(1,repeat(196,length(msg)+1)&'\n')
    nts={{0}}
    cnt=1
    puts(1,'\n')
    while length(nts[cnt]) do
	line = prompt_string(sprintf("%s %d > ",{translate("line"),cnt}))
	if find(255,line) then
	    puts(1,translate("used255")&'\n')
	else
	    nts &= {line}
	    cnt += 1
	end if
    end while
    nts=nts[2..length(nts)-1]
    nts = {rldate()&' '&rltime()}&{rldate()&' '&rltime()}&{subject}&nts
    if length(nts) then notes &= {nts} end if
    puts(1,'\n')
    rec=length(notes)
end procedure
procedure write()
    integer fn
    fn=open(ntFile,"wb")
    puts(fn,compress(sprint(fn,notes)))
    close(fn)
    bak=notes
end procedure
procedure view()
    sequence msg,pos
    justViewed=1
    msg=sprintf("%s%d\n",{translate("note"),rec})
    text_color(6)
    puts(1,msg)
    puts(1,repeat(196,length(msg))&'\n')
    text_color(3)
    printf(1,"%s %s\n%s %s\n%s %s\n",{translate("dat"),notes[rec][1],translate("dat2"),
	     notes[rec][2],translate("subj"),notes[rec][3]})
    for z = 4 to length(notes[rec]) do
	pos=get_position()
	if pos[1] >= maxR-1 then
	    wait()
	    clear_screen()
	end if
	printf(1,"%d> %s\n",{z-3,notes[rec][z]})
    end for
    puts(1,'\n')
end procedure
procedure modify()
    sequence line,nts
    integer k,cnt,ln
    nts={}
    puts(1,translate("doyou")&'\n')
    k=getKey(xlateAll(actions),0)
    puts(1,'\n')
    if k<=4 then
	notes[rec][2]=rldate()&' '&rltime()
    end if
    if k=1 then
	text_color(3)
	for z = 1 to length(notes[rec]) do
	    printf(1,"%s %d --> %s\n",{translate("line"),z,notes[rec][z]})
	    cnt=z
	end for
	text_color(2)
	line=""
	cnt += 1
	while 1 do
	    line=prompt_string(sprintf("%s %d --> ",{translate("line"),cnt}))
	    if equal(line,"") then
		exit
	    elsif find(255,line) then
		puts(1,translate("used255")&'\n')
	    else
		cnt += 1
		nts &= {line}
	    end if
	end while
	notes[rec] &= nts
    elsif k=2 then
	ln=prompt_num(translate("atline")&' ',{1,length(notes[rec])})
	cnt=ln
	text_color(2)
	while 1 do
	    line=prompt_string(sprintf("%s %d --> ",{translate("line"),cnt}))
	    if equal(line,"") then
		exit
	    elsif find(255,line) then
		puts(1,translate("used255")&'\n')
	    else
		cnt += 1
		nts &= {line}
	    end if
	end while
	notes[rec]=insert(notes[rec],nts,ln+3)
    elsif k=3 then
	notes[rec][4]={}
    elsif k=4 then
	ln=prompt_number(translate("atline")&' ',{0,length(notes[rec])-3})
	if ln then
	    ln += 3
	    notes[rec]=remove(notes[rec],ln)
	end if
    end if
end procedure
procedure select()
    integer rc
    rc=prompt_num(sprintf("%s %d): ",{translate("newrec"),rec}),{0,
		     length(notes)})
    if rc=0 then
	return
    end if
    rec=rc
end procedure
procedure delete()
    integer rc
    rc=prompt_num(translate("whichrec"),{-1,length(notes)})
    if rc=-1 then
	return
    elsif rc=0 then
	rc=rec
    end if
    notes=remove(notes,rc)
    if rec>length(notes) then
	rec=length(notes)
    end if
end procedure
procedure search()
    sequence searchFor,
	     recnums,
	     msg
    integer k,k2,nomore,x
    msg=translate("find")&'\n'
    nomore=0
    recnums={}
    clear_screen()
    puts(1,msg)
    puts(1,repeat(196,length(msg))&'\n')
    searchFor=prompt_string('\n'&translate("sfw")&' ')
    if equal(searchFor,"") then
	return
    end if
    puts(1,translate("cs")&'\n')
    k2=getKey(xlateAll({"yes","no"}),1)
    puts(1,"\n"&translate("search")&'\n')
    for z = 1 to length(notes) do
	for y = 1 to length(notes[z]) do
	    if match(searchFor,notes[z][y]) then
		recnums &= z
	    elsif k2=2 then
		if match(upper(searchFor),upper(notes[z][y])) then
		    recnums &= z
		    nomore=1
		    exit
		end if
	    end if
	    if nomore then
		exit
	    end if
	end for
    end for
    recnums=nodupes(recnums) -- Remove duplicates
    if length(recnums)=0 then
	puts(1,translate("notf")&'\n')
    elsif length(recnums)=1 then
	rec=recnums[1]
	view()
    else
	k=1
	x=0
	for z = 1 to length(recnums) do
	    if k=1 then
		rec=recnums[z]
		view()
		wait()
	    elsif k=2 then
		return
	    end if
	    if z < length(recnums) then
		puts(1,translate("seenext")&'\n')
		k=getKey(xlateAll({"yes","no","skip"}),0)
		puts(1,'\n')
	    end if
	end for
    end if
end procedure
procedure current()
    puts(1,translate("fn")&' '&ntFile&'\n')
    printf(1,"%s %d\n%s %d %s\n",{translate("currec"),rec,translate("thereare"),
	     length(notes),translate("records")})
end procedure
procedure openDb()
    integer k
    object fl
    fl=dir("*.db")
    if atom(fl) or length(fl)=1 then
	return
    end if
    if not equal(notes,bak) then
	puts(1,translate("save?")&'\n')
	k=getKey(xlateAll({"yes","no","cancel"}),0)
	if k=1 then
	    write()
	    bak=notes
	elsif k=3 then
	    return
	end if
    end if
    clear_screen()
    for z = 1 to length(fl) do
	fl[z]=fl[z][D_NAME]
    end for
    puts(1,translate("selectone")&'\n')
    k=getKey(fl,0)
    clear_screen()
    welcome()
    bk=notes
    ntFile=fl[k]
    readDb()
    if er=1 then
	notes=bk
	bak=notes
	er=0
    end if
    fn=open("enotes.cfg","w")
    if fn > -1 then
	puts(fn,ntFile)
	close(fn)
    end if
end procedure
procedure new()
    sequence fl
    integer k
    if not equal(notes,bak) then
	puts(1,translate("save?")&'\n')
	k=getKey(xlateAll({"yes","no","cancel"}),0)
	if k=1 then
	    write()
	    bak=notes
	elsif k=3 then
	    return
	end if
    end if
    fl=prompt_string(translate("filen")&' ')&".DB"
    if equal(fl,"") then
	return
    end if
    fn=open(fl,"w")
    if fn=-1 then
	puts(1,fl&' '&translate("ro")&'\n')
	return
    end if
    puts(fn,"{}")
    close(fn)
    notes={}
    bak={}
    fn=open("enotes.cfg","w")
    if fn > -1 then
	puts(fn,ntFile)
	close(fn)
    end if
    ntFile=fl
end procedure
procedure printRec()
    sequence st
    integer pt
    st=sprintf("%s%d\n",{translate("contents"),rec})
    printf(1,"%s%d...\n",{translate("printing"),rec})
    pt=open("prn","w")
    puts(pt,st)
    puts(pt,repeat('-',length(st))&'\n')
    for z = 1 to length(notes[rec]) do
	puts(pt,notes[rec][z]&'\n')
    end for
    close(pt)
end procedure
check4Files()
clear_screen()
welcome()
--bgInt()
addResource("dbase")
addResource("comms")
addResource("errors")
addResource("notes")
procs={routine_id("add"),routine_id("modify"),routine_id("delete"),routine_id(
       "current"),routine_id("select"),routine_id("search"),routine_id("view"),
       routine_id("write"),routine_id("world"),routine_id("new"),routine_id(
       "openDb"),routine_id("printRec")}
readDb()
while 1 do
    pos=get_position()
    if pos[1] = maxR and not justViewed then
	clear_screen()
	welcome()
    end if
    justViewed=0
    key=getKey(xlateAll(comms),0)
    puts(1,'\n')
    if key=0 then
	quit()
	if doQuit then exit end if
    elsif key and key <= 12 then
	if not length(notes) and (key >= 2 and key <= 7 or key=12) then
	    puts(1,'\n'&translate("norecs")&'\n')
	else
	    call_proc(procs[key],{})
	end if
    elsif key=13 then
	quit()
	if doQuit then exit end if
    end if
end while
notes=bak
if doSave then write() end if
